<?php

##########################################################################################
# In order to be able to use this script you need to join the merchant program depending on the country where your store is selling the products
#
# AUSTRALIA - http://shopmania.com.au/ (only supporting AUD, NZD datafeeds)
# ARGENTINA - http://www.shopmania.com.ar/ (only supporting ARS, EUR, USD)       *NEW
# BRASIL - http://www.shopmania.com.br/ (only supporting BRL, USD) 
# BULGARY - http://www.shopmania.bg/ (only supporting BGN, EUR, USD)
# CZECH REPUBLIC - http://www.shop-mania.cz/ (only supporting CZK, EUR, USD)		*NEW
# CHILE - http://www.shopmania.cl/ (only supporting CLP, USD, EUR)       *NEW
# CHINA - http://www.shopmania.cn/ (only supporting CNY, USD)       
# DEUTSCHLAND - http://www.shopmania.de/ (only supporting EUR, USD) 
# FRANCE - http://www.shopmania.fr/ (only supporting EUR, USD datafeeds)
# HUNGARY - http://www.shopmania.hu/ (only supporting HUF, EUR, USD datafeeds)
# INDIA - http://www.shopmania.in/ (only supporting INR, USD datafeeds)
# IRELAND - http://www.shopmania.ie/ (only supporting EUR, GBP datafeeds)
# ITALY - http://www.shopmania.it/ (only supporting EUR, USD datafeeds)
# JAPAN - http://www.shopmania.jp/  (only supporting JPY, USD datafeeds)       
# MEXICO - http://www.shopmania.com.mx/ (only supporting MXN (Mexican peso), USD, EUR datafeeds)
# NETHERLANDS - http://www.shopmania.nl/ (only supporting EUR datafeeds)		*NEW
# POLSKA - http://www.shopmania.pl/ (only supporting PLN, EUR, USD) 
# PORTUGAL - http://www.shopmania.pt/ (only supporting EUR, USD) 
# ROMANIA - http://www.shopmania.ro/ (only supporting RON, EUR, USD datafeeds)
# RUSSIA - http://www.shopmania.ru/ (only supporting RUB, EUR, USD)       
# SERBIA - http://www.shopmania.rs/ (only supporting RSD, EUR)		*NEW	
# SLOVAKIA - http://www.shop-mania.sk/ (only supporting EUR, USD)
# SOUTH AFRICA - http://www.shopmania.co.za/ (only supporting ZAR, USD, EUR)       *NEW
# SPAIN - http://www.shopmania.es/ (only supporting EUR datafeeds) 
# SWEDEN - http://www.shopmania.se/ (only supporting SEK, EUR, USD datafeeds)		*NEW
# TURKEY - http://www.shopmania.com.tr/ (only supporting TRY, EUR, USD)
# US - http://www.shopmania.com/ (only supporting USD, CAD datafeeds)
# UK - http://www.shopmania.co.uk/ (only supporting GBP, EUR, USD datafeeds)
#
# Once you join the program and your application is approved you need to place the file on your server and set up the path to the file on the Merchant Interface
# Files will be  retrieved daily from your server having the products listed automatically on ShopMania
# 
# 
# Options
# @url_param taxes=on (on,off) 
# @url_param storetaxes=on (on,off) 
# @url_param discount=on (on,off) 
# @url_param special=on (on,off) 
# @url_param add_vat=off (on,off) 
# @url_param shipping=off (on,off) 
# @url_param add_tagging=on (on,off) 
# @url_param tagging_params=&utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) 
# @url_param description=on (on,off) 
# @url_param image=on (on,off) 
# @url_param specialprice=on (on,off) 
# @url_param sef=off (on,off) 
# @url_param on_stock=off (on,off) 
# @url_param forcepath=off (on,off) 
# @url_param forcefolder= (FORCEFOLDER) 
# @url_param language= (LANGUAGE_CODE) 
# @url_param language_id= (LANGUAGE_ID) 
# @url_param currency= (CURRENCY_CODE) 
#
# 
##########################################################################################

// Debuging
if (isset($_GET['debug'])) {
	$time_start = microtime(true);
	$time = $time_start;
}


// Current datafeed script version
$script_version = "1.13 (> xc4.5)";

// Print current Script version
if (@$_GET['get'] == "version") {
	echo "<b>Datafeed XCart</b> <br />";
	echo "version <b>" . $script_version . "</b><br />";
	exit;
}

// Set no time limit only if php is not running in Safe Mod
if (!ini_get("safe_mode")) {
   if (function_exists('set_time_limit')) {
		@set_time_limit(0);
	}
	if ((int)substr(ini_get("memory_limit"), 0, -1) < 512) {
		ini_set("memory_limit", "512M");
	}
}

ignore_user_abort();
error_reporting(E_ALL^E_NOTICE);
$_SVR = array();

// Path to config.php file
$site_base_path = "./";

// Include configuration file
if(!file_exists($site_base_path . "auth.php")) {
	exit('<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Please ensure that this file is in the root directory, or make sure the path to the directory where the auth.php file is located is defined corectly above in $site_base_path variable</BODY></HTML>');
}
else {
	require $site_base_path . "auth.php";
}

####################################################################

// Datafeed specific settings
$datafeed_separator = "|"; // Possible options are \t or |
// You can also leave this field empty. Please contact us if you are planning to submit the feeds in a different currency

##### Extract params from url ################################################

$apply_taxes = (@$_GET['taxes'] == "off") ? "off" : "on";
$apply_storetaxes = (@$_GET['storetaxes'] == "off") ? "off" : "on";
$apply_discount = (@$_GET['discount'] == "off") ? "off" : "on";
$add_vat = (@$_GET['add_vat'] == "on") ? "on" : "off";
$vat_value = (@$_GET['vat_value'] > 0) ? ((100 + $_GET['vat_value']) / 100) : 1.24; // default value
$add_shipping = (@$_GET['shipping'] == "on") ? "on" : "off";
$add_availability = (@$_GET['availability'] == "off") ? "off" : "on";
$add_gtin = (@$_GET['gtin'] == "off") ? "off" : "on";
$add_tagging = (@$_GET['add_tagging'] == "off") ? "off" : "on";
$tagging_params = (@$_GET['tagging_params'] != "") ? urldecode($_GET['tagging_params']) : "utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link";
$show_description = (@$_GET['description'] == "off") ? "off" : ((@$_GET['description'] == "limited") ? "limited" : ((@$_GET['description'] == "short") ? "short" : ((@$_GET['description'] == "full") ? "full" : ((@$_GET['description'] == "full_limited") ? "full_limited" : ((@$_GET['description'] > 0) ? $_GET['description'] : "on")))));
$show_image = (@$_GET['image'] == "off") ? "off" : "on";
$show_specialprice = (@$_GET['specialprice'] == "off") ? "off" : "on";
$sef = (@$_GET['sef'] == "on") ? "on" : "off";
$on_stock_only = (@$_GET['on_stock'] == "on") ? "on" : "off";
$language_code = (@$_GET['language'] != "") ? $_GET['language'] : "";
$language_id = (@$_GET['language_id'] != "") ? $_GET['language_id'] : "";
$currency = (@$_GET['currency'] != "") ? $_GET['currency'] : "";
$force_path = (@$_GET['forcepath'] == "on") ? "on" : "off";
$force_folder = (@$_GET['forcefolder'] != "") ? $_GET['forcefolder'] : "";
$force_image_folder = (@$_GET['force_image_folder'] != "") ? $_GET['force_image_folder'] : "products/large";
$gtin_field_name = (@$_GET['gtin_field_name'] != "") ? urldecode($_GET['gtin_field_name']) : "";
$manuf_field_name = (@$_GET['manuf_field_name'] != "") ? $_GET['manuf_field_name'] : "";
$display_currency = (@$_GET['display_currency'] != "") ? $_GET['display_currency'] : "";
$limit = (@$_GET['limit'] > 0) ? $_GET['limit'] : "";

####################################################################

// Print URL options
if (@$_GET['get'] == "options") {
	$script_basepath = "http://" . $_SERVER['HTTP_HOST'] . $_SERVER['PHP_SELF'];
	
	echo "<b>Datafeed XCart</b> <br />";
	echo "version <b>" . $script_version . "</b><br /><br /><br />";
		
	echo "<b>Taxes options</b> - possible values on, off default value on<br />";
	echo "taxes=on (on,off) <a href=\"" . $script_basepath . "?taxes=off" . "\" >" . $script_basepath . "?taxes=off" . "</a><br /><br />";
	
	/*echo "<b>Store taxes options</b> - possible values on, off default value on<br />";
	echo "storetaxes = on (on,off) <a href=\"" . $script_basepath . "?storetaxes=off" . "\" >" . $script_basepath . "?storetaxes=off" . "</a><br /><br />";
	
	echo "<b>Discount options</b> - possible values on, off default value on<br />";
	echo "discount=on (on,off) <a href=\"" . $script_basepath . "?discount=off" . "\" >" . $script_basepath . "?discount=off" . "</a><br /><br />";
	
	echo "<b>Special price options</b> - possible values on, off default value on<br />";
	echo "special=on (on,off) <a href=\"" . $script_basepath . "?special=off" . "\" >" . $script_basepath . "?special=off" . "</a><br /><br />";
	*/
	
	echo "<b>Add VAT to prices</b> - possible values on, off default value off<br />";
	echo "add_vat=off (on,off) <a href=\"" . $script_basepath . "?add_vat=on" . "\" >" . $script_basepath . "?add_vat=on" . "</a><br /><br />";
	
	echo "VAT value - possible values percent value default value 24  - interger or float number ex 19 or 19.5<br />";
	echo "vat_value=24 (VAT_VALUE) <a href=\"" . $script_basepath . "?add_vat=on&vat_value=19" . "\" >" . $script_basepath . "?add_vat=on&vat_value=19" . "</a><br /><br />";

	//echo "<b>Add shipping to datafeed</b> - possible values on, off default value off<br />";
	//echo "shipping=off (on,off) <a href=\"" . $script_basepath . "?shipping=on" . "\" >" . $script_basepath . "?shipping=on" . "</a><br /><br />";
	
	echo "<b>Add availability to datafeed</b> - possible values on, off default value on<br />";
	echo "availability=on (on,off) <a href=\"" . $script_basepath . "?availability=off" . "\" >" . $script_basepath . "?availability=off" . "</a><br /><br />";
	
	//echo "<b>Add GTIN to datafeed</b> - possible values on, off default value on<br />";
	//echo "gtin=on (on,off) <a href=\"" . $script_basepath . "?gtin=off" . "\" >" . $script_basepath . "?gtin=off" . "</a><br /><br />";
	
	echo "<b>Add GA Tagging to product URL</b> - possible values on, off default value on<br />";
	echo "add_tagging=on (on,off) <a href=\"" . $script_basepath . "?add_tagging=off" . "\" >" . $script_basepath . "?add_tagging=off" . "</a><br /><br />";
		
	echo "<b>Add custom Tagging to product URL</b> - possible values url_encode(TAGGING_PARAMS) default value tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link<br />";
	echo "tagging_params=utm_source=shopmania&utm_medium=cpc&utm_campaign=direct_link (TAGGING_PARAMS) <a href=\"" . $script_basepath . "?tagging_params=from%3Dshopmania" . "\" >" . $script_basepath . "?tagging_params=from%3Dshopmania" . "</a><br /><br />";
	
	echo "<b>Display Description options</b> - possible values on, off<br />";
	echo "description=on (on,off) <a href=\"" . $script_basepath . "?description=off" . "\" >" . $script_basepath . "?description=off" . "</a><br /><br />";

	echo "<b>Display image options</b> - possible values on, off default value on<br />";
	echo "image=on (on,off) <a href=\"" . $script_basepath . "?image=off" . "\" >" . $script_basepath . "?image=off" . "</a><br /><br />";
	
	echo "<b>Display currency code</b> - force the display of certain currency code possible values USD,EUR etc. <br />";
	echo "display_currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?display_currency=EUR" . "\" >" . $script_basepath . "?display_currency=EUR" . "</a><br /><br />";
		
	/*echo "<b>Special price options</b> - possible values on, off default value on<br />";
	echo "specialprice=on (on,off) <a href=\"" . $script_basepath . "?specialprice=off" . "\" >" . $script_basepath . "?specialprice=off" . "</a><br /><br />";
	
	echo "<b>Add basepath to product URL</b> - possible values on, off default value off<br />";
	echo "forcepath=off (on,off) <a href=\"" . $script_basepath . "?forcepath=on" . "\" >" . $script_basepath . "?forcepath=on" . "</a><br /><br />";
		
	echo "<b>Get prices in specified currency</b> - possible values USD,EUR etc. <br />";
	echo "currency=DEFAULT_CURRENCY <a href=\"" . $script_basepath . "?currency=EUR" . "\" >" . $script_basepath . "?currency=EUR" . "</a><br /><br />";
	
	echo "<b>Get texts in specified language code</b> - possible values en,ro etc. <br />";
	echo "language=DEFAULT_LANGUAGE_CODE <a href=\"" . $script_basepath . "?language=en" . "\" >" . $script_basepath . "?language=en" . "</a><br /><br />";
	
	echo "<b>Get texts in specified language id</b> - possible values 1,2 etc. <br />";
	echo "language_id=DEFAULT_LANGUAGE_ID <a href=\"" . $script_basepath . "?language_id=1" . "\" >" . $script_basepath . "?language_id=1" . "</a><br /><br />";
	*/

	echo "<b>Get feed paginated</b> - possible values 1,2,..  etc. <br />";
	echo "pg=PAGE <a href=\"" . $script_basepath . "?pg=1" . "\" >" . $script_basepath . "?pg=1" . "</a><br />";
	echo "pg=PAGE&limit=PAGE_SIZE <a href=\"" . $script_basepath . "?pg=1&limit=100" . "\" >" . $script_basepath . "?pg=1&limit=100" . "</a><br /><br />";
	
	echo "<b>Limit displayed products</b> - possible values integer <br />";
	echo "limit=no_limit <a href=\"" . $script_basepath . "?limit=10" . "\" >" . $script_basepath . "?limit=10" . "</a><br /><br />";
	
	echo "<b>Specify custom GTIN field</b> - possible values Extrafield name default value EAN code<br />";
	echo "gtin_field_name=EAN code <a href=\"" . $script_basepath . "?gtin_field_name=UPC" . "\" >" . $script_basepath . "?gtin_field_name=UPC" . "</a><br /><br />";
	
	echo "<b>Specify custom manuf field</b> - possible values MAnufcaturer Extrafield name default value Fabricant<br />";
	echo "manuf_field_name=Fabricant <a href=\"" . $script_basepath . "?manuf_field_name=Manufacturer" . "\" >" . $script_basepath . "?manuf_field_name=Manufacturer" . "</a><br /><br />";
	
	exit;
}

##### Extract options from database ################################################


##### Connect to database ######################################################
// Connect to database
$conn = @mysql_connect($sql_host, $sql_user, $sql_password);
if (mysql_error()) {
	print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Connection error.</BODY></HTML>";
	exit;
}
else {
	@mysql_select_db($sql_db, $conn);
	if (mysql_error()) {
		print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Connection error.</BODY></HTML>";
		exit;
	}
}

######################################################################


##### Extract options from database ################################################

if ($language_code != "") {
	$lang_code = $language_code;
}
else {
	// Detect default language code
	$lang_code = $config['default_customer_language'];
}

// Define tables name
$config_table = "xcart_config"; // config table
$prod_table = "xcart_products"; // products table
$prod_cat_table = "xcart_products_categories"; // products categories table
//$prod_lang_table = "xcart_products_lng" ; // products categories table
$prod_lang_table = "xcart_products_lng_" . $lang_code; // products categories table
$cat_table = "xcart_categories"; // categories table
$pricing_table = "xcart_pricing"; // pricing table
$quick_prices_table = "xcart_quick_prices"; // quick prices table
$xcart_extra_field_values = "xcart_extra_field_values"; // extra filds values
$xcart_extra_fields = "xcart_extra_fields"; // extra filds 
$country_currencies = "xcart_country_currencies"; // extra filds 

// Detect default currency (cmpi_currency / currency_symbol)
$query_currency = @mysql_query("SELECT code FROM $country_currencies WHERE country_code = '" . $config['General']['default_country'] . "'");
//$query_currency = @mysql_query("SELECT value FROM $config_table WHERE name = 'cmpi_currency'");
$row_currency = @mysql_fetch_array($query_currency);

// Set the default currency
$datafeed_currency = $row_currency['value']; 
$datafeed_currency = (strtolower($datafeed_currency) == "lei") ? "RON" : strtoupper($datafeed_currency);

// Force displayed currency
$datafeed_currency = ($display_currency != "") ? $display_currency : $datafeed_currency;

// Get all categories
$res_cat = @mysql_query("SELECT categoryid, parentid, category FROM " . $cat_table);
if (!mysql_error()) {
	while ($field = mysql_fetch_assoc($res_cat)) {
		$CAT_ARR[$field['categoryid']] = $field;
	}
}

// Query database for extracting data. It might be needed to left join the categories table for extracting the category name
$description_field = ($show_description != "off") ? $prod_lang_table . ".descr, " . $prod_lang_table . ".fulldescr" : "'', ''";

$add_avail_cond = "";
if ($config["General"]["disable_outofstock_products"] == "Y") {
	$add_avail_cond = " AND " . $prod_table . ".avail > 0";
}

$ean_field_name = ($gtin_field_name != "") ? $gtin_field_name : "EAN code";
$query_ean = @mysql_query("SELECT fieldid FROM $xcart_extra_fields WHERE field = '" . addslashes($ean_field_name) . "'");
$ean_field = @mysql_fetch_array($query_ean);
$ean_field_id = ($ean_field['fieldid'] > 0) ? $ean_field['fieldid'] : "''";

$man_field_name = ($manuf_field_name != "") ? $manuf_field_name : "Fabricant";
$query_manuf = @mysql_query("SELECT fieldid FROM $xcart_extra_fields WHERE field = '" . addslashes($man_field_name) . "'");
$manuf_field = @mysql_fetch_array($query_manuf);
$manuf_field_id = ($manuf_field['fieldid'] > 0) ? $manuf_field['fieldid'] : "''";

######################################################################


if (isset($_GET['pg']) && @$_GET['pg'] > 0) {
	$_step = ($limit > 0) ? $limit : 1000;
	$_start = ($_GET['pg'] - 1) * $_step;
	$_start = ($_start >= 0) ? $_start : 0;
	$add_limit = " LIMIT " . $_start . "," . $_step;
}

// Debuging
if (isset($_GET['debug'])) {
	// Get prod stats
	$q_res = "SELECT COUNT(if(p.forsale='Y', 1, NULL)) AS active_products, COUNT(p.productid) AS total_products " . " FROM $prod_table p";
	$res_prod_stats = mysql_fetch_assoc(mysql_query($q_res));
	
	echo "Active products: " . $res_prod_stats['active_products'] . "\n";
	echo "Total products: " . $res_prod_stats['total_products'] . "\n\n";
	// Init prod count
	$cnt_prod = 0;
	$add_limit = " LIMIT 0,10";

}


##### Get products data ######################################################

// Enable SQL_BIG_SELECTS
$res  = @mysql_query("SET SESSION SQL_BIG_SELECTS = 1");

$q = "SELECT " . $prod_cat_table . ".categoryid,
	" . $prod_table . ".productid, 
	" . $prod_lang_table . ".product, 
	" . $prod_table . ".avail, 
	" . $description_field . ", 
	" . $prod_table . ".list_price, 
	" . $prod_table . ".discount_avail, 
	" . $prod_table . ".free_tax, 
	ean_table.value, 
	manuf_table.value, 
	" . $pricing_table . ".price

	FROM " . $prod_table . "
	LEFT JOIN " . $prod_lang_table . " ON (" . $prod_table . ".productid = " . $prod_lang_table . ".productid)
	LEFT JOIN " . $prod_cat_table . " ON (" . $prod_table . ".productid = " . $prod_cat_table . ".productid AND " . $prod_cat_table . ".main='Y')
	LEFT JOIN " . $xcart_extra_field_values . " AS ean_table ON (" . $prod_table . ".productid = ean_table.productid AND ean_table.fieldid=" . $ean_field_id . ")
	LEFT JOIN " . $xcart_extra_field_values . " AS manuf_table ON (" . $prod_table . ".productid = manuf_table.productid AND manuf_table.fieldid=" . $manuf_field_id . ")
	LEFT JOIN " . $quick_prices_table . " ON (" . $prod_table . ".productid = " . $quick_prices_table . ".productid AND " . $quick_prices_table . ".membershipid = 0)
	LEFT JOIN " . $pricing_table . " ON (" . $quick_prices_table . ".priceid = " . $pricing_table . ".priceid AND " . $quick_prices_table . ".membershipid = " . $pricing_table . ".membershipid AND " . $quick_prices_table . ".variantid = " . $pricing_table . ".variantid)
	WHERE " . $prod_table . ".forsale = 'Y' " . $add_avail_cond . $add_limit;

	
$r = @mysql_query($q);


######################################################################


##### Print products data ######################################################

$current_id = 0;
$prod_count = 0;

if (!mysql_error()) {
	while (list($cat_id, $prod_id, $prod_name, $stock, $prod_desc, $prod_full_desc, $prod_price, $discount_avail, $free_tax, $ean, $manuf, $quick_price) = mysql_fetch_row($r)) {
	
		// If we've sent this one, skip the rest - this is to ensure that we do not get duplicate products
		if ($current_id == $prod_id) {
			continue;
		}
		else {
			$current_id = $prod_id;
		}
		
		// Get category name
		$category_name = smfeed_get_full_cat($cat_id, $CAT_ARR);
	
		// Clean product name
		$prod_name = str_replace("\n", "", strip_tags($prod_name));
		$prod_name = str_replace("\r", "", strip_tags($prod_name));
		$prod_name = str_replace("\t", " ", strip_tags($prod_name));

		// Limit description size
		if ($show_description == "limited") {
			$prod_desc = ($prod_full_desc != "") ? $prod_full_desc : $prod_desc;
			$prod_desc = strip_tags($prod_desc);
			$prod_desc = substr($prod_desc, 0, 350);
		}
		else {
			if ($show_description == "on") {
				$prod_desc = ($prod_full_desc != "") ? $prod_full_desc : $prod_desc;
			}
			elseif ($show_description == "short") {

			}
			elseif ($show_description == "full") {
				$prod_desc = ($prod_full_desc != "") ? $prod_full_desc : $prod_desc;
			}
			
		}
		
		// Clean description
		$prod_desc = smfeed_clean_description($prod_desc);
		
		// Clean product description (Replace new line with <BR>). In order to make sure the code does not contains other HTML code it might be a good ideea to strip_tags()
		$prod_desc = smfeed_replace_not_in_tags("\n", "<BR />", $prod_desc);
		$prod_desc = str_replace("\n", " ", $prod_desc);		
		$prod_desc = str_replace("\r", "", $prod_desc);
		$prod_desc = str_replace("\t", " ", $prod_desc);

		$prod_url = smfeed_get_product_url($prod_id);		
		// Add GA Tagging parameters to url
		if ($add_tagging == "on") {
			$and_param = (preg_match("/\?/", $row['product_url'])) ? "&" : "?";
			$row['product_url'] = $row['product_url'] . $and_param . $tagging_params;
		}
		
		$prod_image = ($show_image == "on") ? smfeed_get_product_image($prod_id) : "";
		
		// Get product price
		$product_price = ($apply_taxes == "on" && $quick_price > 0) ? $quick_price : $prod_price;
		
		// Add VAT to prices
		if ($add_vat == "on") {
			$product_price = $product_price * $vat_value;
		}
		
		// Clean product names and descriptions (separators)
		if ($datafeed_separator == "\t") {
			$category_name = str_replace("\t", " ", $category_name);
			// Continue... tabs were already removed
		}
		elseif ($datafeed_separator == "|") {
			$prod_name = str_replace("|", " ", strip_tags($prod_name));
			$prod_desc = str_replace("|", " ", $prod_desc);
			$category_name = str_replace("|", " ", $category_name);
		}
		else {
			print "Incorrect columns separator.";
			exit;
		}
			
		// Build stock conditions
		if ($add_availability == "on") {
			if ($stock > 0) {
				$availability = "In stock";
			}
			else {
				$availability = "Out of stock";
			}
		}
		else {
			$availability = "";
		}	
		
		// Add Shipping
		$shipping_value = "";
		
		// Add gtin
		$gtin = ($add_gtin == "on") ? $ean : "";
		
		// Output the datafeed content
		// Category, Manufacturer, Model, ProdCode, ProdName, ProdDescription, ProdURL, ImageURL, Price, Currency, Shipping value, Availability, GTIN (UPC/EAN/ISBN) 
		print 
		$category_name . $datafeed_separator .
		$manuf . $datafeed_separator .
		"" . $datafeed_separator .
		$prod_id . $datafeed_separator .
		$prod_name . $datafeed_separator .
		$prod_desc . $datafeed_separator .
		$prod_url . $datafeed_separator .
		$prod_image . $datafeed_separator .
		$product_price . $datafeed_separator .
		$datafeed_currency . $datafeed_separator .
		$shipping_value . $datafeed_separator .
		$availability . $datafeed_separator . 
		$gtin . "\n";
		
		$prod_count ++;
		
		// Limit displayed products
		if ($limit > 0 && $prod_count >= $limit && !isset($_GET['pg'])) {
			break;
		}
		
	}
}
else {
	print "<HTML><HEAD><TITLE>404 Not Found</TITLE></HEAD><BODY><H1>Not Found</H1>Query error: " . mysql_error() . "</BODY></HTML>";
}

###################################################################


// Debuging
if (isset($_GET['debug'])) {
	echo "\npage loaded in " . number_format(microtime(true) - $time_start, 3) . "s \n"; 
	echo "memory limit " . ini_get("memory_limit") . "\n";
	echo "max_execution_time " . ini_get("max_execution_time") . "\n\n";
}


##### Functions ########################################################

function smfeed_get_product_url($prod_id){	
	global $xcart_http_host, $xcart_web_dir;
	
	return "http://" . $xcart_http_host . $xcart_web_dir . "/product.php?productid=" . $prod_id;	
}

function smfeed_get_product_image($prod_id){
	global $xcart_http_host, $xcart_web_dir;
	
	return "http://" . $xcart_http_host . $xcart_web_dir . "/image.php?type=T&id=" . $prod_id;	
}

function smfeed_get_full_cat($cat_id, $CATEGORY_ARR) {

	$item_arr = $CATEGORY_ARR[$cat_id];
	$cat_name = $item_arr['category'];
	
	while (sizeof($CATEGORY_ARR[$item_arr['parentid']]) > 0 && is_array($CATEGORY_ARR[$item_arr['parentid']]) ) {
		
		$cat_name = $CATEGORY_ARR[$item_arr['parentid']]['category'] . " > " . $cat_name;		
		$item_arr = $CATEGORY_ARR[$item_arr['parentid']];
	}
	
	// Strip html from category name
	$cat_name = smfeed_html_to_text($cat_name);
	
	return $cat_name;
}

function smfeed_html_to_text($string){

	$search = array (
		"'<script[^>]*?>.*?</script>'si",  // Strip out javascript
		"'<[\/\!]*?[^<>]*?>'si",  // Strip out html tags
		"'([\r\n])[\s]+'",  // Strip out white space
		"'&(quot|#34);'i",  // Replace html entities
		"'&(amp|#38);'i",
		"'&(lt|#60);'i",
		"'&(gt|#62);'i",
		"'&(nbsp|#160);'i",
		"'&(iexcl|#161);'i",
		"'&(cent|#162);'i",
		"'&(pound|#163);'i",
		"'&(copy|#169);'i",
		"'&(reg|#174);'i",
		"'&#8482;'i",
		"'&#149;'i",
		"'&#151;'i"
		);  // evaluate as php
	
	$replace = array (
		" ",
		" ",
		"\\1",
		"\"",
		"&",
		"<",
		">",
		" ",
		"&iexcl;",
		"&cent;",
		"&pound;",
		"&copy;",
		"&reg;",
		"<sup><small>TM</small></sup>",
		"&bull;",
		"-",
		);
	
	$text = preg_replace ($search, $replace, $string);
	return $text;
	
}

function smfeed_clean_description($string){

	$search = array (
		"'<html>'i",
		"'</html>'i",
		"'<body>'i",
		"'</body>'i",
		"'<head>.*?</head>'si",
		"'<!DOCTYPE[^>]*?>'si"
		); 
		
	$replace = array (
		"",
		"",
		"",
		"",
		"",
		""
		); 
		
	$text = preg_replace ($search, $replace, $string);
	return $text;

}

function smfeed_replace_not_in_tags($find_str, $replace_str, $string) {
	
	$find = array($find_str);
	$replace = array($replace_str);	
	preg_match_all('#[^>]+(?=<)|[^>]+$#', $string, $matches, PREG_SET_ORDER);	
	foreach ($matches as $val) {	
		if (trim($val[0]) != "") {
			$string = str_replace($val[0], str_replace($find, $replace, $val[0]), $string);
		}
	}	
	return $string;
}

###################################################################

exit;
?>
